package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.service.OrgaoConcedenteService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;

@Controller("editarOrgaoConcedenteController")
@Scope("prototype")
public class EditarOrgaoConcedenteController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private OrgaoConcedenteService orgaoConcedenteService;
	private OrgaoConcedente orgaoConcedente;
	private MyListbox orgaoConcedenteList;
	private MyTextbox txtNome;

	public OrgaoConcedente getOrgaoConcedente() {
		return orgaoConcedente;
	}

	public void setOrgaoConcedente(OrgaoConcedente orgaoConcedente) {
		this.orgaoConcedente = orgaoConcedente;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		orgaoConcedente = (OrgaoConcedente) Executions.getCurrent().getArg().get("orgaoConcedente");
		orgaoConcedenteList = (MyListbox) Executions.getCurrent().getArg().get("orgaoConcedenteList");

		txtNome.focus();
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		if (orgaoConcedente.getOrgaoConcedenteId() == null) {
			orgaoConcedenteService.suscribir(orgaoConcedente);
			orgaoConcedenteList.addItem(orgaoConcedente);
		} else {
			orgaoConcedenteService.actualizacion(orgaoConcedente);
			orgaoConcedenteList.updateItem(orgaoConcedente);
		}

		Messagebox.show(
				Labels.getLabel("editarOrgaoConcedenteController.MSG.suscribirOK"),
				Labels.getLabel("editarOrgaoConcedenteController.window.title"),
				Messagebox.OK, Messagebox.INFORMATION);

		closeWindow();
	}
}
