package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.ConfRestricaoCanalVenta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.ConfRestricaoCanalVentaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

@Controller("editarConfRestricaoCanalVentaController")
@Scope("prototype")
public class EditarConfRestricaoCanalVentaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private ConfRestricaoCanalVentaService confRestricaoCanalVentaService;
	@Autowired
	private TipoPuntoVentaService tipoPtoVtaService;
	private ConfRestricaoCanalVenta confRestricaoCanalVenta;
	private List<TipoPuntoVenta> lsTipoPtoVta;
	private MyListbox confRestricaoCanalVentaList;
	private Button btnApagar;

	public ConfRestricaoCanalVenta getConfRestricaoCanalVenta() {
		return confRestricaoCanalVenta;
	}

	public void setConfRestricaoCanalVenta(ConfRestricaoCanalVenta confRestricaoCanalVenta) {
		this.confRestricaoCanalVenta = confRestricaoCanalVenta;
	}

	public List<TipoPuntoVenta> getLsTipoPtoVta() {
		return lsTipoPtoVta;
	}

	public void setLsTipoPtoVta(List<TipoPuntoVenta> lsTipoPtoVta) {
		this.lsTipoPtoVta = lsTipoPtoVta;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		confRestricaoCanalVenta = (ConfRestricaoCanalVenta) Executions.getCurrent().getArg().get("confRestricaoCanalVenta");
		confRestricaoCanalVentaList = (MyListbox) Executions.getCurrent().getArg().get("confRestricaoCanalVentaList");

		lsTipoPtoVta = tipoPtoVtaService.obtenerTodos();

		super.doAfterCompose(comp);

		if (confRestricaoCanalVenta.getConfRestricaoCanalVentaId() == null) {
			btnApagar.setVisible(Boolean.FALSE);
		}
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		if (confRestricaoCanalVenta.getConfRestricaoCanalVentaId() == null) {
			confRestricaoCanalVentaService.suscribir(confRestricaoCanalVenta);
			confRestricaoCanalVentaList.addItem(confRestricaoCanalVenta);
		} else {
			confRestricaoCanalVentaService.actualizacion(confRestricaoCanalVenta);
			confRestricaoCanalVentaList.updateItem(confRestricaoCanalVenta);
		}

		Messagebox.show(
				Labels.getLabel("editarConfRestricaoCanalVentaController.MSG.suscribirOK"),
				Labels.getLabel("editarConfRestricaoCanalVentaController.window.title"),
				Messagebox.OK, Messagebox.INFORMATION);

		closeWindow();
	}

	public void onClick$btnApagar(Event ev) throws InterruptedException {
		Integer resp = Messagebox.show(
				Labels.getLabel("editarConfRestricaoCanalVentaController.MSG.borrarPergunta"),
				Labels.getLabel("editarConfRestricaoCanalVentaController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp.equals(Messagebox.YES)) {
			confRestricaoCanalVentaService.borrar(confRestricaoCanalVenta);

			Messagebox.show(
					Labels.getLabel("editarConfRestricaoCanalVentaController.MSG.borrarOK"),
					Labels.getLabel("editarConfRestricaoCanalVentaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			confRestricaoCanalVentaList.removeItem(confRestricaoCanalVenta);

			closeWindow();
		}
	}
}
