/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.pricing;

import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Intbox;

import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingAnticipacion;
import com.rjconsultores.ventaboletos.service.PricingAnticipacionService;
import com.rjconsultores.ventaboletos.utilerias.TraslaparUtil;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.ConstraintPorcentagem;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;

/**
 *
 * @author Rafius
 */
@Controller("editarPricingAnticipacionController")
@Scope("prototype")
public class EditarPricingAnticipacionController extends MyGenericForwardComposer {

    @Autowired
    private PricingAnticipacionService pricingAnticipacionService;
    private PricingAnticipacion pricingAnticipacion;
    private MyListbox pricingAnticipacionList;
    private Intbox anticipacioninicial;
    private Intbox anticipacionfinal;
    private MyTextboxDecimal porcentaje;
    private Pricing pricing;
    private ConstraintPorcentagem ct;
    private static Logger log = Logger.getLogger(EditarPricingAnticipacionController.class);

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        ct = new ConstraintPorcentagem();
        pricing = (Pricing) Executions.getCurrent().getArg().get("pricing");
        pricingAnticipacion = (PricingAnticipacion) Executions.getCurrent().getArg().get("pricingAnticipacion");
        pricingAnticipacionList = (MyListbox) Executions.getCurrent().getArg().get("pricingAnticipacionList");

        super.doAfterCompose(comp);
    }

    public void onClick$btnAdicionarAnticipacion(Event ev) throws Exception {
        anticipacioninicial.getValue();
        anticipacionfinal.getValue();
        porcentaje.getValue();

        if (anticipacioninicial.getValue() > 100) {
            Messagebox.show(Labels.getLabel("editarPricingController.anticipacionPorcentaje.value"),
                    Labels.getLabel("editarPricingController.windowAnticipacion.title"),
                    Messagebox.OK, Messagebox.EXCLAMATION);
        } else if (anticipacionfinal.getValue() > 100) {
            Messagebox.show(Labels.getLabel("editarPricingController.anticipacionPorcentaje.value"),
                    Labels.getLabel("editarPricingController.windowAnticipacion.title"),
                    Messagebox.OK, Messagebox.EXCLAMATION);
        } else if (anticipacionfinal.getValue() < anticipacioninicial.getValue()) {
            Messagebox.show(Labels.getLabel("editarPricingController.anticipacionErrada.value"),
                    Labels.getLabel("editarPricingController.windowAnticipacion.title"),
                    Messagebox.OK, Messagebox.EXCLAMATION);

        } else {

            Integer min = pricingAnticipacion.getCantdiasmin();
            Integer max = pricingAnticipacion.getCantdiasmax();
            // Boolean podeSalvar = pricingAnticipacionService.podeSalvar(pricing,
            // min, max);

            boolean existe = true;

            List<PricingAnticipacion> lsPricingAnticipacion = pricingAnticipacionService.obtenerPorPricing(pricingAnticipacion.getPricing());

            if (pricingAnticipacion != null) {
                lsPricingAnticipacion.remove(pricingAnticipacion);
            }
            for (PricingAnticipacion po : lsPricingAnticipacion) {
                if (po.getActivo()) {
                    boolean traslapa = TraslaparUtil.intersectNum(
                            po.getCantdiasmin().longValue(), po.getCantdiasmax().longValue(),
                            min.longValue(), max.longValue());
                    if (traslapa) {
                        existe = false;
                    }
                }
            }

            if (existe) {
                if (pricingAnticipacion.getPricinganticipacionId() != null) {
                    pricingAnticipacionService.actualizacion(pricingAnticipacion);
                    pricingAnticipacionList.updateItem(pricingAnticipacion);
                } else {
                    pricingAnticipacionService.suscribir(pricingAnticipacion);
                    pricingAnticipacionList.addItem(pricingAnticipacion);
                }
                closeWindow();
            } else {
                Messagebox.show(Labels.getLabel("editarPricingController.anticipacionErrada"),
                        Labels.getLabel("editarPricingController.windowAnticipacion.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }

        }
    }

    public void onClick$btnRemoverAnticipacion(Event ev) {
        try {
            PricingAnticipacion pAnticipacion = (PricingAnticipacion) pricingAnticipacionList.getSelected();
            if (pAnticipacion != null) {
                int resp = Messagebox.show(Labels.getLabel("editarPricingController.MSG.borrarPerguntaAnticipacion"),
                        Labels.getLabel("editarPricingController.windowAnticipacion.title"),
                        Messagebox.YES | Messagebox.NO,
                        Messagebox.QUESTION);

                if (resp == Messagebox.YES) {
                    pricingAnticipacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pricingAnticipacion.setFecmodif(Calendar.getInstance().getTime());
                    pricingAnticipacion.setActivo(Boolean.FALSE);

                    pricingAnticipacionList.removeItem(pricingAnticipacion);
                    pricingAnticipacionService.borrar(pricingAnticipacion);
                    closeWindow();
                }
            } else {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"),
                        Labels.getLabel("editarPricingController.windowAnticipacion.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error(ex);
        }

    }

    public PricingAnticipacion getPricingAnticipacion() {
        return pricingAnticipacion;
    }

    public void setPricingAnticipacion(PricingAnticipacion pricingAnticipacion) {
        this.pricingAnticipacion = pricingAnticipacion;
    }

    public MyListbox getPricingAnticipacionList() {
        return pricingAnticipacionList;
    }

    public void setPricingAnticipacionList(MyListbox pricingAnticipacionList) {
        this.pricingAnticipacionList = pricingAnticipacionList;
    }

    public PricingAnticipacionService getPricingAnticipacionService() {
        return pricingAnticipacionService;
    }

    public void setPricingAnticipacionService(
            PricingAnticipacionService pricingAnticipacionService) {
        this.pricingAnticipacionService = pricingAnticipacionService;
    }

    /**
     * @return the ct
     */
    public ConstraintPorcentagem getCt() {
        return ct;
    }

    /**
     * @param ct
     *            the ct to set
     */
    public void setCt(ConstraintPorcentagem ct) {
        this.ct = ct;
    }
}
