/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.recaudacion;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.TarjetaRecaudacion;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTarjetaRecaudacion;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;

/**
 *
 * @author Administrador
 */
@Controller("busquedaTarjetaRecaudacionController")
@Scope("prototype")
public class BusquedaTarjetaRecaudacionController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TarjetaRecaudacion> plwTarjetaRecaudacion;
    @Autowired
    private EmpresaService empresaService;
    private List<Empresa> lsEmpresas;
    private Paging pagingTarjetaRecaudacion;
    private MyListbox tarjetaRecaudacionList;
    private Combobox cmbEmpresas;
    private Intbox txtClaveOperador;
    private Integer claveConductor;

    public List<Empresa> getLsEmpresas() {
        return lsEmpresas;
    }

    public void setLsEmpresas(List<Empresa> lsEmpresas) {
        this.lsEmpresas = lsEmpresas;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsEmpresas = empresaService.buscarTodosExceto(-1);

        super.doAfterCompose(comp);

        tarjetaRecaudacionList.setItemRenderer(new RenderTarjetaRecaudacion());
        tarjetaRecaudacionList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TarjetaRecaudacion tarjetaRecaudacion =
                        (TarjetaRecaudacion) tarjetaRecaudacionList.getSelected();
                verTarjetaRecaudacion(tarjetaRecaudacion);
            }
        });

        claveConductor = (Integer) Executions.getCurrent().getArg().get("claveConductor");
        txtClaveOperador.setValue(claveConductor);
        txtClaveOperador.setDisabled(Boolean.TRUE);
    }

    private void refreshList() {
        Empresa empresa = (Empresa) (cmbEmpresas.getSelectedItem() != null
                ? cmbEmpresas.getSelectedItem().getValue() : null);

        HibernateSearchObject<TarjetaRecaudacion> tarjetasRecaudacionSearch =
                new HibernateSearchObject<TarjetaRecaudacion>(TarjetaRecaudacion.class,
                pagingTarjetaRecaudacion.getPageSize());

        if (empresa != null) {
            tarjetasRecaudacionSearch.addFilterEqual("empresa", empresa);
        }

        if (txtClaveOperador.getValue() != null) {
            tarjetasRecaudacionSearch.addFilterEqual("conductorId",
                    txtClaveOperador.getValue());
        }

        tarjetasRecaudacionSearch.addFilterEqual("activo", Boolean.TRUE);

        tarjetasRecaudacionSearch.addSortAsc("empresa.nombempresa");

        plwTarjetaRecaudacion.init(tarjetasRecaudacionSearch, tarjetaRecaudacionList,
                pagingTarjetaRecaudacion);

        if (tarjetaRecaudacionList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTarjetaRecaudacionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    private void verTarjetaRecaudacion(TarjetaRecaudacion tarjetaRecaudacion) {
        if (tarjetaRecaudacion == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tarjetaRecaudacion", tarjetaRecaudacion);
        args.put("tarjetaRecaudacionList", tarjetaRecaudacionList);
        args.put("claveConductor", claveConductor);

        openWindow("/gui/recaudacion/editarTarjetaRecaudacion.zul",
                Labels.getLabel("editarTarjetaRecaudacionController.window.title"), args, MODAL);
    }

    public void onClick$btnRefresh(Event ev) {
        refreshList();
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshList();
    }

    public void onClick$btnNovo(Event ev) {
        verTarjetaRecaudacion(new TarjetaRecaudacion());
    }

    public void onClick$btnConfirmaPago(Event ev) throws InterruptedException {
        List<Object> lsTarjetaRecaudacion = tarjetaRecaudacionList.getSelectedsItens();

        if (!lsTarjetaRecaudacion.isEmpty()) {
            Map args = new HashMap();
            args.put("lsTarjetaRecaudacion", lsTarjetaRecaudacion);

            openWindow("/gui/recaudacion/pagarTarjetasViajes.zul",
                    Labels.getLabel("pagarTarjetasViajesController.window.title"), args, MODAL);
        } else {
            Messagebox.show(Labels.getLabel("busquedaTarjetaRecaudacionController.MSG.Seleccionar.Tajetas"),
                    Labels.getLabel("busquedaTarjetaRecaudacionController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
        }
    }
}
